/*****************************************************************************
 *
 * cgi_bin_report - CGI reports of Binary data
 *
 * Copyright (c) 2004 Ben Clewett (bclewett@perfparse.org)
 * Last Modified:   2004-05-28
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#include "libpp_common.h"
#include "cgi_bin_report.h"
#include <config.h>
#include <gettext.h>
#include "object_users.h"

/* Local CGI */
char *sHost;
char *sService;
char *sMetric;
char sFrom[22], sTo[22];

void getBinReportCGI();

void displayAllBin()
{
	char sColour[7] = "FFFFFF";
	char sColourHead[7] = "FFFFFF";
	char sState[20];
	char sURL[255];
	int iState;
	#ifdef USE_DB_POSTGRESQL
	int numberOfRows;
	#endif

	getBinReportCGI();

	printf("<p align=center>\n");
	printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
	printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

	printf("  <tr>\n");
	printf("    <td width=60><img src=\"%s%s/perfparse-logo-sm.png\" border=0></td>\n", 
		(HTTP_IMAGE_PATH[0] == '/') ? "" : "/", HTTP_IMAGE_PATH);
	printf("    <td align=center><font face=\"Arial, Helvetica\" size=2>\n");
	printf("      <b>%s</b><br>\n", _("Please select a Metric to Analyse"));
	printf("      <a href=\"%s\">%s</a>\n", sProgName, _("Return to main menu"));
	printf("    </td>\n");
	printf("    <td width=60 align=right><font face=\"Arial, Helvetica\" size=1>v%s</td>\n", VERSION);
	printf("  </tr>\n");
	printf("  </table>\n");

	printf("</td></tr></table></p>\n");

	// Select group:
	selectGroup("all_bin", TRUE);

	if (!user.sGroupName[0]) return;

	g_string_printf(s_SQL, "SELECT perfdata_host.host_name, perfdata_service.service_description, perfdata_service_metric.metric, perfdata_service_metric.unit, perfdata_service_bin.value, perfdata_service_bin.state, perfdata_service_bin.ctime"
		" FROM perfdata_host, perfdata_service, perfdata_service_metric, perfdata_service_bin"
		" WHERE perfdata_host.host_name = perfdata_service.host_name"
		" AND perfdata_service_metric.host_name = perfdata_service.host_name"
		" AND perfdata_service_metric.service_description = perfdata_service.service_description"
		" AND perfdata_service_bin.id = perfdata_service_metric.last_perfdata_bin");
	if (strcmp(user.sGroupName, "**ALL**"))
		g_string_append_printf(s_SQL, " AND group_name = '%s'", sql_escape(user.sGroupName,PERCENT_ESCAPE_CHAR));
	g_string_append_printf(s_SQL, " %s", getDecInc("ORDER BY perfdata_host.host_name"));
	query(s_SQL->str);

	sprintf(sURL, "%s?all_bin=1", sProgName);	

	printf("<table width=\"100%%\" border=1 cellspacing=0 cellpadding=2>\n");
	fflush(stdout);

	printf("<tr>\n");
	printf("  <td bgcolor=\"#%s\" align=center><font face=\"Arial, Helvetica\" size=2>", "FFFFCC");
	displayDecInc("perfdata_host.host_name", sURL, "perfdata_host.host_name");
	printf("%s</td>\n",_("Host"));

	printf("  <td bgcolor=\"#%s\" align=center><font face=\"Arial, Helvetica\" size=2>", "FFFFCC");
	displayDecInc("perfdata_service.service_description", sURL, "perfdata_host.host_name");
	printf("%s</td>\n",_("Service"));

	printf("  <td bgcolor=\"#%s\" align=center width=\"1%%\"><font face=\"Arial, Helvetica\" size=2>", "FFFFCC");
	printf("%s</td>\n",_("Graph"));

	printf("  <td bgcolor=\"#%s\" align=center><font face=\"Arial, Helvetica\" size=2>", "FFFFCC");
	displayDecInc("perfdata_service_metric.metric", sURL, "perfdata_host.host_name");
	printf("%s</td>\n",_("Metric"));

	printf("  <td bgcolor=\"#%s\" align=center width=\"1%%\"><font face=\"Arial, Helvetica\" size=2>", "FFFFCC");
	displayDecInc("perfdata_service_bin.ctime", sURL, "perfdata_host.host_name");
	printf("%s</td>\n",_("Last Reading"));

	printf("  <td bgcolor=\"#%s\" align=center width=\"1%%\"><font face=\"Arial, Helvetica\" size=2>", "FFFFCC");
	displayDecInc("perfdata_service_bin.value", sURL, "perfdata_host.host_name");
	printf("%s</td>\n",_("Value"));

	printf("  <td bgcolor=\"#%s\" align=center width=\"1%%\"><font face=\"Arial, Helvetica\" size=2>", "FFFFCC");
	displayDecInc("perfdata_service_metric.unit", sURL, "perfdata_host.host_name");
	printf("%s</td>\n",_("Unit"));

	printf("  <td bgcolor=\"#%s\" align=center width=\"1%%\"><font face=\"Arial, Helvetica\" size=2>", "FFFFCC");
	printf("%s</td>\n",_("State"));

	printf("</tr>\n");

	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = rows();
	for (currentRow=0;currentRow<numberOfRows;currentRow++){
	#endif

		iState = iData(5);
		strcpy(sColour, sStateColour[iState]);
		strcpy(sState, sStates[iState]);

		printf("<tr>\n");

		/* Host */
		if (!strcmp(sData(0), sHost)) {
			printf("  <td bgcolor=\"#%s\"><font size=2>&nbsp;</td>\n", sColourHead);
		} else {
			strcpy(sHost, sData(0));
			sService[0] = 0;
			printf("  <td bgcolor=\"#%s\"><font face=\"Arial, Helvetica\" size=2>&nbsp;%s&nbsp;</td>\n", sColourHead, sHost);
		}

		/* Service */
		if (!strcmp(sData(1), sService)) {
			printf("  <td bgcolor=\"#%s\"><font size=2>&nbsp;</td>\n", sColourHead);
		} else {
			strcpy(sService, sData(1));
			printf("  <td bgcolor=\"#%s\"><font face=\"Arial, Helvetica\" size=2>&nbsp;%s&nbsp;</td>\n", sColourHead, sService);
		}

		sprintf(sCGIOut, "host=%s", url_encode(sData(0)));
		sprintf(sCGIOut, "%s&service=%s", sCGIOut, url_encode(sData(1)));
		sprintf(sCGIOut, "%s&metric=%s", sCGIOut, url_encode(sData(2)));

		/* Graph */
		printf("  <td align=\"center\" bgcolor=\"#%s\"><font face=\"Arial, Helvetica\" size=\"2\"><a href=%s?graph=1&%s>", 
			sColour, sProgName, sCGIOut);
		printf("<img src=\"%s%s/perfgraph-sm.png\" border=0></a></td>", 
			(HTTP_IMAGE_PATH[0] == '/') ? "" : "/", HTTP_IMAGE_PATH);

		printf("  <td bgcolor=\"#%s\"><font face=\"Arial, Helvetica\" size=2>&nbsp;%s&nbsp;</td>\n", sColour, sData(2));
		printf("  <td bgcolor=\"#%s\"><font face=\"Arial, Helvetica\" size=2><nobr>&nbsp;%s&nbsp;</td>\n", sColour, sData(6));
		printf("  <td bgcolor=\"#%s\" align=right><font face=\"Arial, Helvetica\" size=2>&nbsp;%s&nbsp;</td>\n", sColour, sData(4));
		printf("  <td bgcolor=\"#%s\"><font face=\"Arial, Helvetica\" size=2>&nbsp;%s&nbsp;</td>\n", sColour, sData(3));
		printf("  <td bgcolor=\"#%s\"><font face=\"Arial, Helvetica\" size=2>&nbsp;%s&nbsp;</td>\n", sColour, sState);

		printf("</tr>\n");

	}

	printf("</table>\n");
	

}



void getBinReportCGI()
{

	sHost = strdup(scgi("host"));
	sService = strdup(scgi("service"));
	sMetric = strdup(scgi("metric"));

	strcpy(sFrom, scgi("from"));
	strcpy(sTo, scgi("to"));

}

