/*****************************************************************************
 *
 * cgi_host_groups - CGI to define the host groups.
 *
 * Copyright (c) 2004 Ben Clewett (bclewett@perfparse.org)
 * Last Modified:   2004-05-28
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#include <config.h>
#include <gettext.h>
#include <libpp_common.h>
#include "cgi_host_groups.h"

void displayEditHostGroup()
{

	char sGroupName[76];
	int bHeader = FALSE;
	char sDelete[255];
	char sHostName[76];
	int bDeleted = FALSE;
	char sColour[7];

	#ifdef USE_DB_POSTGRESQL
	int numberOfRows;
	#endif

	strcpy(sGroupName, scgi("group_name"));
	strcpy(sHostName, scgi("host_name"));

	printf("<p align=center>\n");
	printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
	printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

	printf("  <tr>\n");
	printf("    <td width=60><img src=\"%s%s/perfparse-logo-sm.png\" border=0></td>\n", 
		(HTTP_IMAGE_PATH[0] == '/') ? "" : "/", HTTP_IMAGE_PATH);
	printf("    <td align=center><font face=\"Arial, Helvetica\" size=2>\n");
	printf("      <b>%s</b><br>\n",_("Edit a Host Group List"));
	printf("      <a href=\"%s\">%s</a><br>\n", sProgName, _("Return to main menu"));
	printf("      <a href=\"%s?add_amend_host_group=1\">%s</a>\n", sProgName, _("Edit Host Groups"));
	printf("    </td>\n");
	printf("    <td width=60 align=right><font face=\"Arial, Helvetica\" size=1>v%s</td>\n", VERSION);
	printf("  </tr>\n");
	printf("  </table>\n");

	printf("</td></tr></table></p>\n");


	// Select:

	printf("<form method=\"get\">\n");
	printf("<input type=hidden name=\"edit_host_list\" value=\"1\">\n");

	printf("<p align=center>\n");
	printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
	printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

	printf("  <tr>\n");
	printf("    <td align=center width=\"33%%\"><font face=\"Arial, Helvetica\" size=2>\n");
	printf("      %s\n",_("Select Host Group:"));
	printf("    </td>\n");
	printf("    <td>\n");
	printf("       <select name=\"group_name\">\n");
	query("SELECT group_name FROM perfdata_host_group");
	
	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
		printf("<option%s>%s", (!strcmp(sData(0), sGroupName)) ? " selected" : "", sData(0));
	}
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = PQntuples(query_result);
	for (currentRow = 0; currentRow<numberOfRows; currentRow++){
		printf("<option%s>%s", (!strcmp(sData(0), sGroupName)) ? " selected" : "", sData(0));
	}
	#endif
	printf("       </select>\n");
	printf("       <input type=submit value=\"%s\">\n",_("Enter"));
	printf("    </td></form>\n");
	printf("  </tr>\n");
	printf("  </table>\n");

	printf("</td></tr></table></p>\n");

	if (!sGroupName[0]) return;

	// Add a new host:
	
	if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_HOST_GROUP), USER_PERMISSIONS_RW)) {

		if (icgi("add", 0)) addHostToGroup(sHostName, sGroupName);

		printf("<form method=\"get\">\n");
		printf("<input type=hidden name=\"edit_host_list\" value=\"1\">\n");
		printf("<input type=hidden name=\"group_name\" value=\"%s\">\n", sGroupName);
		printf("<input type=hidden name=\"add\" value=\"1\">\n");

		printf("<p align=center>\n");
		printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
		printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

		printf("  <tr>\n");
		printf("    <td align=center width=\"33%%\"><font face=\"Arial, Helvetica\" size=2>\n");
		printf("      %s\n",_("Add new Host to Group:"));
		printf("    </td>\n");
		printf("    <td>\n");
		printf("       <select name=\"host_name\">\n");
		query("SELECT host_name FROM perfdata_host WHERE group_name IS NULL");
		#ifdef USE_DB_MYSQL
		while ((result_row = mysql_fetch_row(query_result))) {
		#elif defined USE_DB_POSTGRESQL
		numberOfRows = PQntuples(query_result);
		for (currentRow = 0; currentRow<numberOfRows; currentRow++){
		#endif
		
			if (!sData(0)[0]) continue;
			printf("<option>%s", sData(0));
		}
		printf("       </select>\n");
		printf("       <input type=submit value=\"%s\">\n",_("Enter"));
		printf("    </td></form>\n");
		printf("  </tr>\n");
		printf("  </table>\n");

		printf("</td></tr></table></p>\n");

	}

	// Show hosts:


	g_string_printf(s_SQL, "SELECT host_name, group_name FROM perfdata_host WHERE group_name = '%s'", sql_escape(sGroupName,PERCENT_ESCAPE_CHAR));
	query(s_SQL->str);

	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = rows();
	for (currentRow = 0; currentRow<numberOfRows; currentRow++){
	#endif

		if (!bHeader) {
			bHeader = TRUE;
			printf("<p align=center>\n");
			printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
			printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

			printf("  <tr>\n");
			printf("    <td align=center><font face=\"Arial, Helvetica\" size=2>\n");
			printf("      <b>%s</b><br>\n", _("Host List"));
			printf("    </td>\n");
			printf("  </tr>\n");
			printf("  </table>\n");

			printf("  <table width=\"100%%\" border=1 cellpadding=2 cellspacing=0>\n");
			printf("    <tr bgcolor=\"#FFFFCC\">\n");
			printf("      <td align=center><font face=\"Arial, Helvetica\" size=2><b>%s</b></td>\n",_("Host&nbsp;Name"));
			if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_HOST_GROUP), USER_PERMISSIONS_RW)) {
				printf("      <td align=center width=\"1%%\"><font face=\"Arial, Helvetica\" size=2><b>%s</td>\n",_("Remove"));
			}
			printf("    </tr>\n");
		}

		bDeleted = FALSE;
		strcpy(sColour, "FFFFFF");
		if (icgi("delete", 0)) {
			if (!strcmp(sData(0), sHostName)) {
				deleteHostFromGroup(sHostName);
				bDeleted = TRUE;
				strcpy(sColour, "FFCCCC");
			}
		}
					
		snprintf(sDelete, 255, "<a href=\"%s?edit_host_list=1&delete=1&group_name=%s", sProgName, url_encode(sGroupName));
		sprintf(sDelete, "%s&host_name=%s\">%s</a>\n", sDelete, url_encode(sData(0)), _("Remove"));

		printf("    <tr bgcolor=\"#%s\">\n", sColour);
		printf("      <td><font face=\"Arial, Helvetica\" size=2>%s</td>\n", sData(0));

		if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_HOST_GROUP), USER_PERMISSIONS_RW)) {

			if (bDeleted) {
				printf("      <td align=center><font face=\"Arial, Helvetica\" size=2><b>%s</b></td>\n",_("Deleted."));
			} 
			else {
				printf("      <td align=center><font face=\"Arial, Helvetica\" size=2>%s</td>\n", sDelete);
			}
		}

		printf("    </tr>\n");


	}

	if (bHeader) printf("</table></tr></td></table></p>\n");
	

}




void displayAddAmendHostGroup()
{

	int bHeader = FALSE;
	char sDelete[80], sEdit[80];
	char *s, *sHash;
	char sColour[7];
	int bDeleted = FALSE;

	#ifdef USE_DB_POSTGRESQL
	int numberOfRows;
	#endif

	printf("<p align=center>\n");
	printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
	printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

	printf("  <tr>\n");
	printf("    <td width=60><img src=\"%s%s/perfparse-logo-sm.png\" border=0></td>\n", 
		(HTTP_IMAGE_PATH[0] == '/') ? "" : "/", HTTP_IMAGE_PATH);
	printf("    <td align=center><font face=\"Arial, Helvetica\" size=2>\n");
	printf("      <b>%s</b><br>\n",_("View / Edit Host Groups"));
	printf("      <a href=\"%s\">%s</a>\n", sProgName,_("Return to main menu"));
	printf("    </td>\n");
	printf("    <td width=60 align=right><font face=\"Arial, Helvetica\" size=1>v%s</td>\n", VERSION);
	printf("  </tr>\n");
	printf("  </table>\n");

	printf("</td></tr></table></p>\n");

	// Add:

	s = scgi("group_name");
	if (s[0]) {
		addGroup(s);
	}

	printf("<form method=\"get\">\n");
	printf("<input type=hidden name=\"add_amend_host_group\" value=\"1\">\n");

	if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_HOST_GROUP), USER_PERMISSIONS_RW)) {

		printf("<p align=center>\n");
		printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
		printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

		printf("  <tr>\n");
		printf("    <td align=center><font face=\"Arial, Helvetica\" size=2>\n");
		printf("      %s\n",_("Add New Group:"));
		printf("    </td>\n");
		printf("    <td><input name=\"group_name\" value=\"\" size=20 maxlength=20>\n");
		printf("       <input type=submit value=\"%s\">\n",_("Enter"));
		printf("    </td></form>\n");
		printf("  </tr>\n");
		printf("  </table>\n");

		printf("</td></tr></table></p>\n");

	}

	// Table

	query("SELECT perfdata_host_group.group_name, count(host_name) FROM perfdata_host_group LEFT OUTER JOIN perfdata_host ON perfdata_host_group.group_name = perfdata_host.group_name GROUP BY perfdata_host_group.group_name");

	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = rows();
	for (currentRow = 0; currentRow<numberOfRows; currentRow++){
	#endif

		sHash = s_hash(sData(0));

		// Do we deletre this entry?
		s = scgi("delete");
		if (!strcmp(s, sHash)) {
			deleteGroup(sData(0));
			strcpy(sColour, "FFCCCC");
			bDeleted = TRUE;
		} else {
			strcpy(sColour, "FFFFFF");
			bDeleted = FALSE;
		}

		if (!bHeader) {
			bHeader = TRUE;
			printf("<p align=center>\n");
			printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
			printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

			printf("  <tr>\n");
			printf("    <td align=center><font face=\"Arial, Helvetica\" size=2>\n");
			printf("      <b>%s</b><br>\n",_("Groups"));
			printf("    </td>\n");
			printf("  </tr>\n");
			printf("  </table>\n");

			printf("  <table width=\"100%%\" border=1 cellpadding=2 cellspacing=0>\n");
			printf("    <tr bgcolor=\"#FFFFCC\">\n");
			printf("      <td align=center><font face=\"Arial, Helvetica\" size=2><b>%s</b></td>\n",_("Group&nbsp;Name"));
			printf("      <td align=center width=\"1%%\"><font face=\"Arial, Helvetica\" size=2><b>%s</b></td>\n",_("Host&nbsp;Count"));
			printf("      <td align=center width=\"1%%\"><font face=\"Arial, Helvetica\" size=2><b>%s</b></td>\n",_("Delete"));
			printf("      <td align=center width=\"1%%\"><font face=\"Arial, Helvetica\" size=2><b>%s</b></td>\n",_("Host&nbsp;List"));
			printf("    </tr>\n");
		}

		if (iData(1) > 0)
			sprintf(sDelete, "&nbsp;");
		else
			sprintf(sDelete, "<a href=\"%s?add_amend_host_group=1&delete=%s\">%s</a>", sProgName, sHash,_("Delete"));

		sprintf(sEdit, "<a href=\"%s?edit_host_list=1&group_name=%s\">%s</a>", 
			sProgName, url_encode(sData(0)),
			(strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_HOST_GROUP), USER_PERMISSIONS_RW))?_("View"):_("Edit"));

		printf("    <tr bgcolor=\"#%s\">\n", sColour);
		printf("      <td><font face=\"Arial, Helvetica\" size=2>%s</td>\n", sData(0));
		if (bDeleted) {
			printf("      <td colspan=3 align=center><font face=\"Arial, Helvetica\" size=2><b>%s</b></td>\n",_("Deleted."));
		} 
		else {
			printf("      <td align=right><font face=\"Arial, Helvetica\" size=2>%s</td>\n", sData(1));
			printf("      <td align=center><font face=\"Arial, Helvetica\" size=2>%s</td>\n", sDelete);
			printf("      <td align=center><font face=\"Arial, Helvetica\" size=2>%s</td>\n", sEdit);
		}
		printf("    </tr>\n");


	}

	if (bHeader) printf("</table></tr></td></table></p>\n");
	
}


