/*****************************************************************************
 *
 * cgi_into - Display an Intro to the CGI
 *
 * Copyright (c) 2004 Ben Clewett (bclewett@perfparse.org)
 * Last Modified:   2004-05-28
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <libpp_common.h>
#include "db_macro_actions.h"
#include "cgi_intro.h"
#include <config.h>
#include <gettext.h>
#include <locale.h>

void displayIntroHeader();

void displayIntro()
{

	displayIntroHeader();

	printf("  <tr><td colspan=3 align=center><font face=\"Arial, Helvetica\" size=2>\n");
	printf("    <b>%s</b>\n",_("Data Analysis Options"));
	printf("  </font></td></tr>\n");

	printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
	printf("    <a href=\"%s?select_host=1\">%s</a>\n", sProgName,_("Graph Binary Data"));
	printf("  </font></td></tr>\n");

	printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
	printf("    <a href=\"%s?all_bin=1\">%s</a>\n", sProgName, _("View and Graph Binary Data"));
	printf("  </font></td></tr>\n");

	printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
	printf("    <a href=\"%s?all_raw=1\">%s</a></td>\n", sProgName, _("View Raw Plugin Data"));
	printf("  </font></td></tr>\n");

	printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
	printf("    <a href=\"%s?saved_graphs=1\">%s</a></td>\n", sProgName, _("View Stored Graphs"));
	printf("  </font></td></tr>\n");

	/* Only show Admin Menu if one or more admin options are visible. */

	if (strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), 
		USER_PERMISSIONS_HIDE) ||
	    strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_SUMMARY), 
	    	USER_PERMISSIONS_HIDE) ||
	    strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_HOST_GROUP), 
	    	USER_PERMISSIONS_HIDE)) {

		printf("  <tr><td colspan=3><hr width=\"96%%\"</td></tr>\n");

		printf("  <tr><td colspan=3 align=center><font face=\"Arial, Helvetica\" size=2>\n");
		printf("    <b>%s</b>\n",_("Administration"));
		printf("  </font></td></tr>\n");

		printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
		printf("    <a href=\"%s?admin_menu=1\">%s</a></td>\n", sProgName, _("Administration Menu"));
		printf("  </font></td></tr>\n");

	}


	printf("  </table>\n");
	printf("</td></tr></table></p>\n");
}





void displayAdminIntro()
{
	displayIntroHeader();

	printf("  <tr><td colspan=3 align=center><font face=\"Arial, Helvetica\" size=2>\n");
	printf("    <b>%s</b>\n",_("Administration"));
	printf("  </font></td></tr>\n");

	/* Host Groups */

	if (strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_HOST_GROUP), 
		USER_PERMISSIONS_HIDE)) {

		printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
		printf("    <a href=\"%s?add_amend_host_group=1\">%s</a>\n", sProgName,_("View / Edit Host Groups"));
		printf("  </font></td></tr>\n");

		printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
		printf("    <a href=\"%s?edit_host_list=1\">%s</a>\n", sProgName, _("View / Edit Host Groups List"));
		printf("  </font></td></tr>\n");

		printf("  <tr><td colspan=2>&nbsp;</td></tr>\n");

	}


	/* Sumamry Data */

	if (strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_SUMMARY), 
		USER_PERMISSIONS_HIDE)) {

		printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
		printf("    <a href=\"%s?define_bin_summary=1\">%s</a>\n", sProgName, _("View / Edit Binary Summary Definition"));
		printf("  </font></td></tr>\n");

		printf("  <tr><td colspan=2>&nbsp;</td></tr>\n");

	}


	/* Deletion Templates */

	if (strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), 
		USER_PERMISSIONS_HIDE)) {

		printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
		printf("    <a href=\"%s?edit_delete_policies=1\">%s</a>\n", sProgName,_("View / Edit Deletion Policy Templates"));
		printf("  </font></td></tr>\n");

		printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
		printf("    <a href=\"%s?edit_host_delete_policies=1\">%s</a>\n", sProgName,_("View / Edit Hosts Deletion Policy"));
		printf("  </font></td></tr>\n");

		printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
		printf("    <a href=\"%s?delete_policy_bin=1\">%s</a>\n", sProgName,_("View / Edit Binary Data Deletion Policy"));
		printf("  </font></td></tr>\n");

		printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
		printf("    <a href=\"%s?delete_policy_raw=1\">%s</a>\n", sProgName,_("View / Edit Raw Data Deletion Policy"));
		printf("  </font></td></tr>\n");

		printf("  <tr><td colspan=2>&nbsp;</td></tr>\n");

		printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
		printf("    <a href=\"%s?mark_for_deletion=1\">%s</a>\n", sProgName,_("Mark hosts for complete data deletion"));
		printf("  </font></td></tr>\n");
	}

	printf("  <tr><td colspan=3><hr width=\"96%%\"</td></tr>\n");

	printf("  <tr><td></td><td colspan=2><font face=\"Arial, Helvetica\" size=2>\n");
	printf("    <a href=\"%s\">%s</a>\n", sProgName, _("Main Menu"));
	printf("  </font></td></tr>\n");

	printf("  </table>\n");
	printf("</td></tr></table></p>\n");


}





void displayIntroHeader()
{

	printf("<p align=center>\n");
	printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\">\n");
	printf("<tr><td>\n");
	printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");
	printf("  <tr>\n");
	printf("    <td colspan=3 align=center><img src=\"%s%s/perfparse-logo.png\" border=0></td>\n",
		(HTTP_IMAGE_PATH[0] == '/') ? "" : "/", HTTP_IMAGE_PATH);
	printf("  </tr>\n");
	printf("  <tr>\n");
	printf("    <td width=\"10%%\">&nbsp;</td>\n");
	printf("    <td align=center><font face=\"Arial, Helvetica\" size=2>\n");

	fflush(stdout);

	printf("      <b><a href=\"http://perfparse.sourceforge.net\">%s</a></b><br>\n",_("PerfParse"));
	printf("      ");
	setlocale(LC_NUMERIC, "POSIX"); 
	printf(_("Copyright &copy; 2004. Program Version %s. Schema Version %.2f."),
		VERSION, getVersion());
	setlocale(LC_NUMERIC, ""); 
	printf("</b></font>\n");

	fflush(stdout);

	printf("    </td>\n");
	printf("    <td width=\"10%%\" align=right><font face=\"Arial, Helvetica\" size=1>&nbsp;</td>\n");
	printf("  </tr>\n");
	printf("  </font><tr><td colspan=3><hr width=\"96%%\"</td></tr>\n");

}



