/*****************************************************************************
 *
 * perfgraph.c - Common program to display all CGI.
 *
 * Copyright (c) 2004 Ben Clewett (bclewett@perfparse.org)
 * Last Modified:   2004-05-28
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#ifndef PP_PERFGRAPH_H
#define PP_PERFGRAPH_H

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <errno.h>
#include <glib.h>
#include <string.h>
#include <unistd.h>
#include <math.h>

#define FONT "<font face=\"Arial, Helvetica\" size=\"2\">"
#define FONT_SMALL "<font face=\"Arial, Helvetica\" size=\"1\">"

#include "common.h"
#include "dbms.h"
#include "cgi.h"
#include "del_policy.h"
#include <config.h>

/* TODO: Turn these into an enum */
#define GRAPH_DISPLAY				1
#define ALL_BIN_DISPLAY				2
#define ALL_RAW_DISPLAY				3
#define DELETE_POLICY_BIN_DISPLAY		4
#define DELETE_POLICY_RAW_DISPLAY		5
#define ADD_AMEND_HOST_GROUP			6
#define EDIT_HOST_GROUP				7
#define SELECT_HOST				8
#define SELECT_METRIC				9
#define EDIT_DELETE_POLICIES			10
#define EDIT_HOST_DELETE_POLICIES		11
#define RAW_HISTORY				12
#define SAVED_GRAPHS				13
#define MARK_FOR_DELETION			14
#define VIEW_SAVED_GRAPH			15
#define EDIT_SAVED_GRAPH			16
#define DEFINE_BIN_SUMMARY			17
#define ADMIN_MENU				18
#define RAW_HISTORY_SUMMARY			19

/* Common SQL varables */
extern int iDisplay;

/* Special CGI variable needed by header */
extern char sOutput[10];
extern char sCGIOut[1024];

void displayOptions();
void displayUnsupported();
void displayDatabaseError();
void header();
void header_meta();
void header_refresh(int iSeconds);
void headerGraphDisplay();
void footer();
void showHeader(char *sTitle, char *sExtraOptions);

void doSQL();
void doXML();
void doCSV();
/* void fail(FILE *f, char *sMsg); */
char *getPath(char *);
void getTimeRange(time_t tIn, char *sFrom, char *sTo);
void addGroup(char *sGroup);
void deleteGroup(char *sGroup);
void deleteHostFromGroup(char *sHostName);
void addHostToGroup(char *sHostName, char *sGroupName);
void selectGroup(char *sMenuOptionName, int bTerminateTable);

/* Ordering Controls */
void displayDecInc(char *sfield, char *sURL, char *sDefault);
char *getDecInc(char *sDefault);

/* Program Name */
extern char *sProgName;

/* Misk utilities */
void getRelativeToAbsolte(int iDays, char *sTime, time_t *t0, time_t *t1, char *sFromIn, char *sToIn);

#endif

