/*****************************************************************************
 *
 * common.h - Common functions required by PerfParse suit.
 *
 * Copyright (c) Fabalabs Software GmbH, 2005
 *   oss@fabalabs.org
 *   Author: Friedrich Priewasser (friedrich.priewasser@fabalabs.org)
 *   Last Modified:   2005-01-13
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#ifndef PERF_PARSE_COMMON_H
#define PERF_PARSE_COMMON_H

#include <config.h>
#include <gettext.h>

#define DB_VERSION 0.18
#define DB_VERSION_CHAR "0.18"


#define OK 1
#define ERROR 0


/* States */
extern char *sStates[4];
extern char *sStateColour[4];


/* Hash */
#define HASHSIZE 1509949439
char *s_hash(const char *name);
unsigned long hash(const char *name);

/* Debugs */
#define DL { \
	printf("%05d:HERE\n", __LINE__); \
	fflush(stdout); \
}
#define DL2(s) { \
	printf("%05d:HERE \"%s\"\n", __LINE__, s); \
	fflush(stdout); \
}

#define STRING_DELETE_POLICY_BIN_DEFAULT N_("Bin Default")
#define STRING_DELETE_POLICY_RAW_DEFAULT N_("Raw Default")
#define STRING_DELETE_POLICY_HOST_DEFAULT N_("Host Default")
#define STRING_DELETE_POLICY_USER_DEFINED N_("User Defined")
#endif

/* location of tmp stats file used between graph and chart code */
#define FILE_STATISTICS "/tmp/pp_graph_stats.dat"
