/*****************************************************************************
 *
 * storgae_mysql.h - Parse Nagios data and store in relational database.
 *
 * Copyright (c) 2004 Yves Mettier (ymettier@libertysurf.fr)
 * Last Modified:   2004-09-01
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#ifndef __STORAGE_MYSQL_MODULE__
#define __STORAGE_MYSQL_MODULE__

#include <time.h>

#define STORAGE_MYSQL_VERSION "0.0.1"

int storage_mysql_init(void);

/* Stats */
typedef struct {
 int iAddedHost;
 int iAddedService;
 int iAddedMetric;
 int iAddedBinary;
 int iAddedRaw;
 time_t tStart;
 int iRead;
 int iSQLCount;
 int iAddedSummaryMetric;
 int iAddedSummary;
} mysql_statistics_t; 

typedef struct {
	mysql_statistics_t *statistics;
} mysql_user_params_t;

#define MYSQL_USER_PARAMS(x) ((mysql_user_params_t*)(x))


#endif
