/*****************************************************************************
 *
 * storgae_postgresql.h - Parse Nagios data and store in relational database.
 *
 * Copyright (c) Fabalabs Software GmbH, 2005
 *   oss@fabalabs.org
 *   Author: Friedrich Priewasser (friedrich.priewasser@fabalabs.org)
 *   Last Modified:   2005-01-13
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#ifndef __STORAGE_POSTGRESQL_MODULE__
#define __STORAGE_POSTGRESQL_MODULE__

#include <time.h>

#define STORAGE_POSTGRESQL_VERSION "0.0.1"

int storage_postgresql_init(void);

/* Stats */
typedef struct {
 int iAddedHost;
 int iAddedService;
 int iAddedMetric;
 int iAddedBinary;
 int iAddedRaw;
 time_t tStart;
 int iRead;
 int iSQLCount;
 int iAddedSummaryMetric;
 int iAddedSummary;
} postgresql_statistics_t; 

typedef struct {
	postgresql_statistics_t *statistics;
} postgresql_user_params_t;

#define POSTGRESQL_USER_PARAMS(x) ((postgresql_user_params_t*)(x))


#endif
