/*****************************************************************************
 *
 * perfparse-common.h - Parse Nagios data and store in relational database.
 *
 * Copyright (c) 2004 Yves Mettier (ymettier@libertysurf.fr)
 * Last Modified:   2004-09-01
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/


#ifndef __PERFPARSE_COMMON__
#define __PERFPARSE_COMMON__

#include <libnagios_perfdata_parser.h>
#include <glib.h>

typedef struct {
	int nb_lines_parsed;
	int nb_metrics_parsed;
	int nb_lines_dropped;
	double reading_rate;
	time_t start_time;
} perfparse_statistics_t;

void registry_update(void);
void log_dropped_line(char*line);
int parse_and_store_perf_data_line(GString*l, perfparse_statistics_t*stats, log_line_t *log_data, perf_fields_t *perf_fields);

#endif
